/* Linearization */
#include "WaterTank_TestSingleWaterTank_model.h"
#if defined(__cplusplus)
extern "C" {
#endif

const char *WaterTank_TestSingleWaterTank_linear_model_frame()
{
  return "model linear_WaterTank_TestSingleWaterTank\n  parameter Integer n = 2; // states\n  parameter Integer k = 0; // top-level inputs\n  parameter Integer l = 0; // top-level outputs\n"
  "  parameter Real x0[2] = {%s};\n"
  "  parameter Real u0[0] = {%s};\n"
  "  parameter Real A[2,2] = [%s];\n"
  "  parameter Real B[2,0] = zeros(2,0);%s\n"
  "  parameter Real C[0,2] = zeros(0,2);%s\n"
  "  parameter Real D[0,0] = zeros(0,0);%s\n"
  "  Real x[2](start=x0);\n"
  "  input Real u[0];\n"
  "  output Real y[0];\n"
  "\n    Real 'x_tank.valve_outflow_int' = x[1];\n  Real 'x_tank.volume' = x[2];\n\n"
  "equation\n  der(x) = A * x + B * u;\n  y = C * x + D * u;\nend linear_WaterTank_TestSingleWaterTank;\n";
}
const char *WaterTank_TestSingleWaterTank_linear_model_datarecovery_frame()
{
  return "model linear_WaterTank_TestSingleWaterTank\n  parameter Integer n = 2; // states\n  parameter Integer k = 0; // top-level inputs\n  parameter Integer l = 0; // top-level outputs\n  parameter Integer nz = 10; // data recovery variables\n"
  "  parameter Real x0[2] = {%s};\n"
  "  parameter Real u0[0] = {%s};\n"
  "  parameter Real z0[10] = {%s};\n"
  "  parameter Real A[2,2] = [%s];\n"
  "  parameter Real B[2,0] = zeros(2,0);%s\n"
  "  parameter Real C[0,2] = zeros(0,2);%s\n"
  "  parameter Real D[0,0] = zeros(0,0);%s\n"
  "  parameter Real Cz[10,2] = [%s];\n"
  "  parameter Real Dz[10,0] = zeros(10,0);%s\n"
  "  Real x[2](start=x0);\n"
  "  input Real u[0];\n"
  "  output Real y[0];\n"
  "  output Real z[10];\n"
  "\n  Real 'x_tank.valve_outflow_int' = x[1];\n  Real 'x_tank.volume' = x[2];\n  Real 'z_control1.level' = z[1];\n  Real 'z_control1.valve' = z[2];\n  Real 'z_tank.drain_p_e' = z[3];\n  Real 'z_tank.fs_inflow' = z[4];\n  Real 'z_tank.tank_p_f' = z[5];\n  Real 'z_tank.valve_outflow' = z[6];\n  Real 'z_tank.valve_powerIn_p' = z[7];\n  Real 'z_tank.valve_powerIn_phi' = z[8];\n  Real 'z_tank.valve_powerOut_f' = z[9];\n  Real 'z_tank.valve_puddle' = z[10];\n\n"
  "equation\n  der(x) = A * x + B * u;\n  y = C * x + D * u;\n  z = Cz * x + Dz * u;\nend linear_WaterTank_TestSingleWaterTank;\n";
}
#if defined(__cplusplus)
}
#endif

